/*****************************************************************************
 * HInt1Image.h
 ***************************************************************************** *
 * Project:     Halcon/libhalcon
 * Description: Signed Byte Images
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.8 $
 * $Date: 2000/02/25 08:29:12 $
 *
 */


#ifndef H_INT1_IMAGE_H
#define H_INT1_IMAGE_H



class LIntExport HInt1Image: public HImage {
public:
  HInt1Image(void);
  HInt1Image(const char *file);
  HInt1Image(const HImage &image);
  HInt1Image(const HInt1Image &image);
  HInt1Image(int width, int height);
  HInt1Image(int *ptr, int width, int height);
  virtual ~HInt1Image(void);
  
  // Tools
  const char *ClassName(void) const { return "HInt1Image"; }

  // Pixelzugriff [k]
  INT1 &operator[] (long k);
    //{ if (!privat) Private(); return ((INT1*)ptr)[k]; }
  INT1  operator[] (long k) const;
    //{ if (!init) ((HInt1Image*)this)->Init(); return ((INT1*)ptr)[k]; }
  
  // Pixelzugriff (k)
  INT1 &operator() (long k)
  { if (!privat) Private(); return ((INT1*)ptr)[k]; }
  INT1  operator() (long k) const
  { if (!init) ((HInt1Image*)this)->Init(); return ((INT1*)ptr)[k]; }
  
  // Pixelzugriff (x,y)
  INT1 &operator()(int x, int y) 
  { if (!privat) Private();
    return ((INT1*)ptr)[HLinearCoord(x,y,width)]; }
  INT1  operator()(int x, int y) const
  { if (!init) ((HInt1Image*)this)->Init(); 
    return ((INT1*)ptr)[HLinearCoord(x,y,width)]; }

  // Klassenoperationen
  static long NumInst(void) { return num_images; }
protected:
private:
  static long num_images;
};


#endif
