/*****************************************************************************
 * HIntDef.h
 *****************************************************************************
 *
 * Project:     Halcon/libhalcon
 * Description: Definition of integer data types
 *              These definitions can be controlled by the compiler
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 *
 *****************************************************************************
 *
 *  $Revision: 1.7 $
 *  $Date: 2000/09/13 09:36:18 $
 *
 */

#ifndef HINTDEF_H
#define HINTDEF_H

#ifndef WIN32
#define  INT      int               /* integer, signed   2-8 Byte      */
#define  UINT     unsigned int      /* integer, unsigned 2-8 Byte      */
#endif

#ifndef _INT16
#define _INT16   short
#endif

#ifndef _INT32
#define _INT32   int
#endif

#ifndef _INT64
#define _INT64   long
#endif

#ifndef _MACHINE_WORD
#define _MACHINE_WORD  long
#endif

#ifndef _DOUBLE8
#define DOUBLE8 double
#else
#ifndef TRIMEDIA
#define DOUBLE8 _DOUBLE8
#else
#define DOUBLE8 long double
#endif
#endif


#ifdef SGI
#define  INT1     signed char       /* integer, signed 1 Byte         */
#else
#define  INT1     char              /* integer, signed 1 Byte         */
#endif
#define  UINT1    unsigned char     /* integer, unsigned 1 Byte       */
#define  INT2     _INT16            /* integer, signed 2 Byte         */
#define  UINT2    unsigned _INT16   /* integer, unsigned 2 Byte       */
#define  INT4     _INT32            /* integer, signed 4 Byte         */
#define  UINT4    unsigned _INT32   /* integer, unsigned 4 Byte       */
#define  INT4_8   _INT64            /* integer, signed 4-8 Byte       */
#define  UINT4_8  unsigned _INT64   /* integer, unsigned 4-8 Byte     */
#define  MACHINE_WORD  _MACHINE_WORD  /* only for memory management   */
				      /* (HAlloc.c)                   */


#endif
