/*****************************************************************************
 * HXLDModParaArray.h
 ***************************************************************************** 
 *
 * Projekt:     Halcon/libhalcon
 * Description: Class HXLDModParaArray
 *
 * (c) 1996-2001 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.12 $
 * $Date: 2001/11/22 13:46:55 $
 */

#ifndef XLD_MOD_PARA_ARRAY_H
#define XLD_MOD_PARA_ARRAY_H

/****************************************************************************/
/*                               HXLDModParaArray                           */
/****************************************************************************/

class LIntExport HXLDModParaArray: public HXLDArray {
public:
  HXLDModParaArray(void) : HXLDArray() {num_xld_mod_para_arrays++;}
  HXLDModParaArray(Hkey *key, long num);
  HXLDModParaArray(const Hobject &obj);
  HXLDModParaArray(const HXLDModPara &mod_para);
  HXLDModParaArray(const HXLD &xld);
  HXLDModParaArray(const HXLDModParaArray &arr);
  HXLDModParaArray(const HXLDArray &arr);
  ~HXLDModParaArray(void) {num_xld_mod_para_arrays--;}

  HXLDModParaArray &operator= (const HXLDModParaArray &arr);
  HXLDModParaArray &operator= (const HXLDArray &arr);

  // Tools
  virtual const char *HClassName(void)    const;
  virtual const char *ClassName(void)     const;
  virtual const char *InstClassName(void) const;
  virtual       INT4  ClassDBID(void)     const {return XLD_MOD_PARALLEL_ID;}
  virtual       Hkey  Key(long i)         const {return array[i].Key();}
  virtual    Hobject  ElemId(long i)      const {return array[i].Id();}

  // Access and Manipulation
  HXLDModPara  const   &operator[] (long index) const;
  HXLDModPara          &operator[] (long index);
  HXLDModParaArray      operator() (long min, long max) const;
  HXLDModParaArray     &Append(const HXLDModPara &mod_para);
  HXLDModParaArray     &Append(const HXLD &xld);
  HXLDModParaArray     &Append(const HXLDModParaArray &mod_para);
  HXLDModParaArray     &Append(const HXLDArray &xlds);
  virtual void          SetKeys(Hkey *key, long num);
  void                  CopyHXLDModParaArray(const HXLDModParaArray &in);
  void                  CopyHXLDArray(const HXLDArray &in);

  // Class Functions
  static long NumInst(void) {return num_xld_mod_para_arrays;}

private:
  static long   num_xld_mod_para_arrays; 
  void          NewLength(long new_num, long old_num);

public:
};

#endif
